#!/bin/bash

# IP-адрес, который нужно удалить из правил iptables
IP_TO_REMOVE="13.107.246.67"

# Массив хостов, на которых будут удалены правила
HOSTS=(
  "p-jenkins-fatnode01.devops.lmru.tech"
  "p-jenkins-node-l-01.devops.lmru.tech"
  "p-jenkins-node-l-02.devops.lmru.tech"
  "p-jenkins-node-l-03.devops.lmru.tech"
  "p-jenkins-node-m-01.devops.lmru.tech"
  "p-jenkins-node-m-02.devops.lmru.tech"
  "p-jenkins-node-m-03.devops.lmru.tech"
  "p-jenkins-node-m-04.devops.lmru.tech"
  "p-jenkins-node-m-05.devops.lmru.tech"
  "p-jenkins-node-m-06.devops.lmru.tech"
  "p-jenkins-node-m-07.devops.lmru.tech"
  "p-jenkins-node-m-08.devops.lmru.tech"
  "p-jenkins-node-m-09.devops.lmru.tech"
  "p-jenkins-node-m-10.devops.lmru.tech"
  "p-jenkins-node-m-11.devops.lmru.tech"
  "p-jenkins-node-m-12.devops.lmru.tech"
  "p-jenkins-node-m-13.devops.lmru.tech"
  "p-jenkins-node-m-14.devops.lmru.tech"
  "p-jenkins-node-m-15.devops.lmru.tech"
  "p-jenkins-node-m-16.devops.lmru.tech"
  "p-jenkins-node-m-17.devops.lmru.tech"
  "p-jenkins-node-m-18.devops.lmru.tech"
  "p-jenkins-node-m-19.devops.lmru.tech"
  "p-jenkins-node-m-20.devops.lmru.tech"
  "p-jenkins-node-m-21.devops.lmru.tech"
)

# Команды для удаления правил iptables
DELETE_RULES=(
  "iptables -D OUTPUT -d $IP_TO_REMOVE -j REJECT"
  "iptables -D FORWARD -d $IP_TO_REMOVE -j REJECT"
  "iptables -D DOCKER-USER -d $IP_TO_REMOVE -j REJECT"
)

# Функция для выполнения команд на удалённом хосте через SSH
remove_ip_rules() {
  local host=$1
  echo "Удаление правил iptables для IP $IP_TO_REMOVE на хосте $host"
  
  for rule in "${DELETE_RULES[@]}"; do
    ssh root@"$host" "$rule"
    if [ $? -eq 0 ]; then
      echo "Команда выполнена: $rule на хосте $host"
    else
      echo "Ошибка выполнения команды: $rule на хосте $host"
    fi
  done
}

# Цикл по каждому хосту и выполнение удаления
for host in "${HOSTS[@]}"; do
  remove_ip_rules "$host"
done

